Index: palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4671)
@@ -2243,50 +2266,50 @@
 !--       is applied so that the resulting albedo is calculated via the weighted
 !--       average of respective surface fractions.
-          DO  m = 1, surf_lsm_h%ns
-!
-!--          Spectral albedos for vegetation/pavement/water surfaces
-             DO  ind_type = 0, 2
-                IF ( surf_lsm_h%albedo_type(m,ind_type) /= 0 )  THEN
-                   surf_lsm_h%aldif(m,ind_type) =                              &
-                               albedo_pars(1,surf_lsm_h%albedo_type(m,ind_type))
-                   surf_lsm_h%asdif(m,ind_type) =                              &
-                               albedo_pars(2,surf_lsm_h%albedo_type(m,ind_type))
-                   surf_lsm_h%aldir(m,ind_type) =                              &
-                               albedo_pars(1,surf_lsm_h%albedo_type(m,ind_type))
-                   surf_lsm_h%asdir(m,ind_type) =                              &
-                               albedo_pars(2,surf_lsm_h%albedo_type(m,ind_type))
-                   surf_lsm_h%albedo(m,ind_type) =                             &
-                               albedo_pars(0,surf_lsm_h%albedo_type(m,ind_type))
-                ENDIF
-             ENDDO
-
-          ENDDO
-!
-!--       For urban surface only if albedo has not been already initialized
-!--       in the urban-surface model via the ASCII file.
-          IF ( .NOT. surf_usm_h%albedo_from_ascii )  THEN
-             DO  m = 1, surf_usm_h%ns
-!
-!--             Spectral albedos for wall/green/window surfaces
+          DO l = 0, 1
+             DO  m = 1, surf_lsm_h(l)%ns
+!
+!--             Spectral albedos for vegetation/pavement/water surfaces
                 DO  ind_type = 0, 2
-                   IF ( surf_usm_h%albedo_type(m,ind_type) /= 0 )  THEN
-                      surf_usm_h%aldif(m,ind_type) =                           &
-                               albedo_pars(1,surf_usm_h%albedo_type(m,ind_type))
-                      surf_usm_h%asdif(m,ind_type) =                           &
-                               albedo_pars(2,surf_usm_h%albedo_type(m,ind_type))
-                      surf_usm_h%aldir(m,ind_type) =                           &
-                               albedo_pars(1,surf_usm_h%albedo_type(m,ind_type))
-                      surf_usm_h%asdir(m,ind_type) =                           &
-                               albedo_pars(2,surf_usm_h%albedo_type(m,ind_type))
-                      surf_usm_h%albedo(m,ind_type) =                          &
-                               albedo_pars(0,surf_usm_h%albedo_type(m,ind_type))
+                   IF ( surf_lsm_h(l)%albedo_type(m,ind_type) /= 0 )  THEN
+                      surf_lsm_h(l)%aldif(m,ind_type) =                              &
+                                  albedo_pars(1,surf_lsm_h(l)%albedo_type(m,ind_type))
+                      surf_lsm_h(l)%asdif(m,ind_type) =                              &
+                                  albedo_pars(2,surf_lsm_h(l)%albedo_type(m,ind_type))
+                      surf_lsm_h(l)%aldir(m,ind_type) =                              &
+                                  albedo_pars(1,surf_lsm_h(l)%albedo_type(m,ind_type))
+                      surf_lsm_h(l)%asdir(m,ind_type) =                              &
+                                  albedo_pars(2,surf_lsm_h(l)%albedo_type(m,ind_type))
+                      surf_lsm_h(l)%albedo(m,ind_type) =                             &
+                                  albedo_pars(0,surf_lsm_h(l)%albedo_type(m,ind_type))
                    ENDIF
                 ENDDO
 
              ENDDO
-          ENDIF
+!
+!--          For urban surface only if albedo has not been already initialized
+!--          in the urban-surface model via the ASCII file.
+             IF ( .NOT. surf_usm_h(l)%albedo_from_ascii )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+!
+!--                Spectral albedos for wall/green/window surfaces
+                   DO  ind_type = 0, 2
+                      IF ( surf_usm_h(l)%albedo_type(m,ind_type) /= 0 )  THEN
+                         surf_usm_h(l)%aldif(m,ind_type) =                           &
+                                  albedo_pars(1,surf_usm_h(l)%albedo_type(m,ind_type))
+                         surf_usm_h(l)%asdif(m,ind_type) =                           &
+                                  albedo_pars(2,surf_usm_h(l)%albedo_type(m,ind_type))
+                         surf_usm_h(l)%aldir(m,ind_type) =                           &
+                                  albedo_pars(1,surf_usm_h(l)%albedo_type(m,ind_type))
+                         surf_usm_h(l)%asdir(m,ind_type) =                           &
+                                  albedo_pars(2,surf_usm_h(l)%albedo_type(m,ind_type))
+                         surf_usm_h(l)%albedo(m,ind_type) =                          &
+                                  albedo_pars(0,surf_usm_h(l)%albedo_type(m,ind_type))
+                      ENDIF
+                   ENDDO
+                ENDDO
+             ENDIF
+          ENDDO
 
           DO l = 0, 3
-
              DO  m = 1, surf_lsm_v(l)%ns
 !
@@ -2338,86 +2361,88 @@
 !
 !--          Horizontal
-             DO  m = 1, surf_lsm_h%ns
-                i = surf_lsm_h%i(m)
-                j = surf_lsm_h%j(m)
-!
-!--             Spectral albedos for vegetation/pavement/water surfaces
-                DO  ind_type = 0, 2
-                   IF ( albedo_pars_f%pars_xy(0,j,i) /= albedo_pars_f%fill )   &
-                      surf_lsm_h%albedo(m,ind_type) =                          &
-                                             albedo_pars_f%pars_xy(0,j,i)
-                   IF ( albedo_pars_f%pars_xy(1,j,i) /= albedo_pars_f%fill )   &
-                      surf_lsm_h%aldir(m,ind_type) =                           &
-                                             albedo_pars_f%pars_xy(1,j,i)
-                   IF ( albedo_pars_f%pars_xy(1,j,i) /= albedo_pars_f%fill )   &
-                      surf_lsm_h%aldif(m,ind_type) =                           &
-                                             albedo_pars_f%pars_xy(1,j,i)
-                   IF ( albedo_pars_f%pars_xy(2,j,i) /= albedo_pars_f%fill )   &
-                      surf_lsm_h%asdir(m,ind_type) =                           &
-                                             albedo_pars_f%pars_xy(2,j,i)
-                   IF ( albedo_pars_f%pars_xy(2,j,i) /= albedo_pars_f%fill )   &
-                      surf_lsm_h%asdif(m,ind_type) =                           &
-                                             albedo_pars_f%pars_xy(2,j,i)
+             DO l = 0, 1
+                DO  m = 1, surf_lsm_h(l)%ns
+                   i = surf_lsm_h(l)%i(m)
+                   j = surf_lsm_h(l)%j(m)
+   !
+   !--             Spectral albedos for vegetation/pavement/water surfaces
+                   DO  ind_type = 0, 2
+                      IF ( albedo_pars_f%pars_xy(0,j,i) /= albedo_pars_f%fill )   &
+                         surf_lsm_h(l)%albedo(m,ind_type) =                          &
+                                                albedo_pars_f%pars_xy(0,j,i)
+                      IF ( albedo_pars_f%pars_xy(1,j,i) /= albedo_pars_f%fill )   &
+                         surf_lsm_h(l)%aldir(m,ind_type) =                           &
+                                                albedo_pars_f%pars_xy(1,j,i)
+                      IF ( albedo_pars_f%pars_xy(1,j,i) /= albedo_pars_f%fill )   &
+                         surf_lsm_h(l)%aldif(m,ind_type) =                           &
+                                                albedo_pars_f%pars_xy(1,j,i)
+                      IF ( albedo_pars_f%pars_xy(2,j,i) /= albedo_pars_f%fill )   &
+                         surf_lsm_h(l)%asdir(m,ind_type) =                           &
+                                                albedo_pars_f%pars_xy(2,j,i)
+                      IF ( albedo_pars_f%pars_xy(2,j,i) /= albedo_pars_f%fill )   &
+                         surf_lsm_h(l)%asdif(m,ind_type) =                           &
+                                                albedo_pars_f%pars_xy(2,j,i)
+                   ENDDO
                 ENDDO
+!
+!--             For urban surface only if albedo has not been already initialized
+!--             in the urban-surface model via the ASCII file.
+                IF ( .NOT. surf_usm_h(l)%albedo_from_ascii )  THEN
+                   DO  m = 1, surf_usm_h(l)%ns
+                      i = surf_usm_h(l)%i(m)
+                      j = surf_usm_h(l)%j(m)
+!
+!--                   Broadband albedos for wall/green/window surfaces
+                      DO  ind_type = 0, 2
+                         IF ( albedo_pars_f%pars_xy(0,j,i) /= albedo_pars_f%fill )&
+                            surf_usm_h(l)%albedo(m,ind_type) =                       &
+                                                albedo_pars_f%pars_xy(0,j,i)
+                      ENDDO
+!
+!--                   Spectral albedos especially for building wall surfaces
+                      IF ( albedo_pars_f%pars_xy(1,j,i) /= albedo_pars_f%fill )  THEN
+                         surf_usm_h(l)%aldir(m,ind_veg_wall) =                       &
+                                                   albedo_pars_f%pars_xy(1,j,i)
+                         surf_usm_h(l)%aldif(m,ind_veg_wall) =                       &
+                                                   albedo_pars_f%pars_xy(1,j,i)
+                      ENDIF
+                      IF ( albedo_pars_f%pars_xy(2,j,i) /= albedo_pars_f%fill )  THEN
+                         surf_usm_h(l)%asdir(m,ind_veg_wall) =                       &
+                                                   albedo_pars_f%pars_xy(2,j,i)
+                         surf_usm_h(l)%asdif(m,ind_veg_wall) =                       &
+                                                   albedo_pars_f%pars_xy(2,j,i)
+                      ENDIF
+!
+!--                   Spectral albedos especially for building green surfaces
+                      IF ( albedo_pars_f%pars_xy(3,j,i) /= albedo_pars_f%fill )  THEN
+                         surf_usm_h(l)%aldir(m,ind_pav_green) =                      &
+                                                   albedo_pars_f%pars_xy(3,j,i)
+                         surf_usm_h(l)%aldif(m,ind_pav_green) =                      &
+                                                   albedo_pars_f%pars_xy(3,j,i)
+                      ENDIF
+                      IF ( albedo_pars_f%pars_xy(4,j,i) /= albedo_pars_f%fill )  THEN
+                         surf_usm_h(l)%asdir(m,ind_pav_green) =                      &
+                                                   albedo_pars_f%pars_xy(4,j,i)
+                         surf_usm_h(l)%asdif(m,ind_pav_green) =                      &
+                                                   albedo_pars_f%pars_xy(4,j,i)
+                      ENDIF
+!
+!--                   Spectral albedos especially for building window surfaces
+                      IF ( albedo_pars_f%pars_xy(5,j,i) /= albedo_pars_f%fill )  THEN
+                         surf_usm_h(l)%aldir(m,ind_wat_win) =                        &
+                                                   albedo_pars_f%pars_xy(5,j,i)
+                         surf_usm_h(l)%aldif(m,ind_wat_win) =                        &
+                                                   albedo_pars_f%pars_xy(5,j,i)
+                      ENDIF
+                      IF ( albedo_pars_f%pars_xy(6,j,i) /= albedo_pars_f%fill )  THEN
+                         surf_usm_h(l)%asdir(m,ind_wat_win) =                        &
+                                                   albedo_pars_f%pars_xy(6,j,i)
+                         surf_usm_h(l)%asdif(m,ind_wat_win) =                        &
+                                                   albedo_pars_f%pars_xy(6,j,i)
+                      ENDIF
+
+                   ENDDO
+                ENDIF
              ENDDO
-!
-!--          For urban surface only if albedo has not been already initialized
-!--          in the urban-surface model via the ASCII file.
-             IF ( .NOT. surf_usm_h%albedo_from_ascii )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   i = surf_usm_h%i(m)
-                   j = surf_usm_h%j(m)
-!
-!--                Broadband albedos for wall/green/window surfaces
-                   DO  ind_type = 0, 2
-                      IF ( albedo_pars_f%pars_xy(0,j,i) /= albedo_pars_f%fill )&
-                         surf_usm_h%albedo(m,ind_type) =                       &
-                                             albedo_pars_f%pars_xy(0,j,i)
-                   ENDDO
-!
-!--                Spectral albedos especially for building wall surfaces
-                   IF ( albedo_pars_f%pars_xy(1,j,i) /= albedo_pars_f%fill )  THEN
-                      surf_usm_h%aldir(m,ind_veg_wall) =                       &
-                                                albedo_pars_f%pars_xy(1,j,i)
-                      surf_usm_h%aldif(m,ind_veg_wall) =                       &
-                                                albedo_pars_f%pars_xy(1,j,i)
-                   ENDIF
-                   IF ( albedo_pars_f%pars_xy(2,j,i) /= albedo_pars_f%fill )  THEN
-                      surf_usm_h%asdir(m,ind_veg_wall) =                       &
-                                                albedo_pars_f%pars_xy(2,j,i)
-                      surf_usm_h%asdif(m,ind_veg_wall) =                       &
-                                                albedo_pars_f%pars_xy(2,j,i)
-                   ENDIF
-!
-!--                Spectral albedos especially for building green surfaces
-                   IF ( albedo_pars_f%pars_xy(3,j,i) /= albedo_pars_f%fill )  THEN
-                      surf_usm_h%aldir(m,ind_pav_green) =                      &
-                                                albedo_pars_f%pars_xy(3,j,i)
-                      surf_usm_h%aldif(m,ind_pav_green) =                      &
-                                                albedo_pars_f%pars_xy(3,j,i)
-                   ENDIF
-                   IF ( albedo_pars_f%pars_xy(4,j,i) /= albedo_pars_f%fill )  THEN
-                      surf_usm_h%asdir(m,ind_pav_green) =                      &
-                                                albedo_pars_f%pars_xy(4,j,i)
-                      surf_usm_h%asdif(m,ind_pav_green) =                      &
-                                                albedo_pars_f%pars_xy(4,j,i)
-                   ENDIF
-!
-!--                Spectral albedos especially for building window surfaces
-                   IF ( albedo_pars_f%pars_xy(5,j,i) /= albedo_pars_f%fill )  THEN
-                      surf_usm_h%aldir(m,ind_wat_win) =                        &
-                                                albedo_pars_f%pars_xy(5,j,i)
-                      surf_usm_h%aldif(m,ind_wat_win) =                        &
-                                                albedo_pars_f%pars_xy(5,j,i)
-                   ENDIF
-                   IF ( albedo_pars_f%pars_xy(6,j,i) /= albedo_pars_f%fill )  THEN
-                      surf_usm_h%asdir(m,ind_wat_win) =                        &
-                                                albedo_pars_f%pars_xy(6,j,i)
-                      surf_usm_h%asdif(m,ind_wat_win) =                        &
-                                                albedo_pars_f%pars_xy(6,j,i)
-                   ENDIF
-
-                ENDDO
-             ENDIF
 !
 !--          Vertical
@@ -2530,95 +2555,96 @@
 !--       to zero in order to take effect.
           IF ( building_surface_pars_f%from_file )  THEN
-             DO  m = 1, surf_usm_h%ns
-                i = surf_usm_h%i(m)
-                j = surf_usm_h%j(m)
-                k = surf_usm_h%k(m)
-!
-!--             Iterate over surfaces in column, check height and orientation
-                DO  is = building_surface_pars_f%index_ji(1,j,i), &
-                         building_surface_pars_f%index_ji(2,j,i)
-                   IF ( building_surface_pars_f%coords(4,is) == -surf_usm_h%koff .AND. &
-                        building_surface_pars_f%coords(1,is) == k )  THEN
-
-                      IF ( building_surface_pars_f%pars(ind_s_alb_b_wall,is) /=      &
-                           building_surface_pars_f%fill )  THEN
-                         surf_usm_h%albedo(m,ind_veg_wall) =                         &
-                                  building_surface_pars_f%pars(ind_s_alb_b_wall,is)
-                         surf_usm_h%albedo_type(m,ind_veg_wall) = 0
+             DO l = 0, 1
+                DO  m = 1, surf_usm_h(l)%ns
+                   i = surf_usm_h(l)%i(m)
+                   j = surf_usm_h(l)%j(m)
+                   k = surf_usm_h(l)%k(m)
+   !
+   !--             Iterate over surfaces in column, check height and orientation
+                   DO  is = building_surface_pars_f%index_ji(1,j,i), &
+                            building_surface_pars_f%index_ji(2,j,i)
+                      IF ( building_surface_pars_f%coords(4,is) == -surf_usm_h(l)%koff .AND. &
+                           building_surface_pars_f%coords(1,is) == k )  THEN
+
+                         IF ( building_surface_pars_f%pars(ind_s_alb_b_wall,is) /=      &
+                              building_surface_pars_f%fill )  THEN
+                            surf_usm_h(l)%albedo(m,ind_veg_wall) =                         &
+                                     building_surface_pars_f%pars(ind_s_alb_b_wall,is)
+                            surf_usm_h(l)%albedo_type(m,ind_veg_wall) = 0
+                         ENDIF
+
+                         IF ( building_surface_pars_f%pars(ind_s_alb_l_wall,is) /=      &
+                              building_surface_pars_f%fill )  THEN
+                            surf_usm_h(l)%aldir(m,ind_veg_wall) =                          &
+                                     building_surface_pars_f%pars(ind_s_alb_l_wall,is)
+                            surf_usm_h(l)%aldif(m,ind_veg_wall) =                          &
+                                     building_surface_pars_f%pars(ind_s_alb_l_wall,is)
+                            surf_usm_h(l)%albedo_type(m,ind_veg_wall) = 0
+                         ENDIF
+
+                         IF ( building_surface_pars_f%pars(ind_s_alb_s_wall,is) /=      &
+                              building_surface_pars_f%fill )  THEN
+                            surf_usm_h(l)%asdir(m,ind_veg_wall) =                          &
+                                     building_surface_pars_f%pars(ind_s_alb_s_wall,is)
+                            surf_usm_h(l)%asdif(m,ind_veg_wall) =                          &
+                                     building_surface_pars_f%pars(ind_s_alb_s_wall,is)
+                            surf_usm_h(l)%albedo_type(m,ind_veg_wall) = 0
+                         ENDIF
+
+                         IF ( building_surface_pars_f%pars(ind_s_alb_b_win,is) /=       &
+                              building_surface_pars_f%fill )  THEN
+                            surf_usm_h(l)%albedo(m,ind_wat_win) =                          &
+                                     building_surface_pars_f%pars(ind_s_alb_b_win,is)
+                            surf_usm_h(l)%albedo_type(m,ind_wat_win) = 0
+                         ENDIF
+
+                         IF ( building_surface_pars_f%pars(ind_s_alb_l_win,is) /=       &
+                              building_surface_pars_f%fill )  THEN
+                            surf_usm_h(l)%aldir(m,ind_wat_win) =                           &
+                                     building_surface_pars_f%pars(ind_s_alb_l_win,is)
+                            surf_usm_h(l)%aldif(m,ind_wat_win) =                           &
+                                     building_surface_pars_f%pars(ind_s_alb_l_win,is)
+                            surf_usm_h(l)%albedo_type(m,ind_wat_win) = 0
+                         ENDIF
+
+                         IF ( building_surface_pars_f%pars(ind_s_alb_s_win,is) /=       &
+                              building_surface_pars_f%fill )  THEN
+                            surf_usm_h(l)%asdir(m,ind_wat_win) =                           &
+                                     building_surface_pars_f%pars(ind_s_alb_s_win,is)
+                            surf_usm_h(l)%asdif(m,ind_wat_win) =                           &
+                                     building_surface_pars_f%pars(ind_s_alb_s_win,is)
+                            surf_usm_h(l)%albedo_type(m,ind_wat_win) = 0
+                         ENDIF
+
+                         IF ( building_surface_pars_f%pars(ind_s_alb_b_green,is) /=     &
+                              building_surface_pars_f%fill )  THEN
+                            surf_usm_h(l)%albedo(m,ind_pav_green) =                        &
+                                     building_surface_pars_f%pars(ind_s_alb_b_green,is)
+                            surf_usm_h(l)%albedo_type(m,ind_pav_green) = 0
+                         ENDIF
+
+                         IF ( building_surface_pars_f%pars(ind_s_alb_l_green,is) /=     &
+                              building_surface_pars_f%fill )  THEN
+                            surf_usm_h(l)%aldir(m,ind_pav_green) =                         &
+                                     building_surface_pars_f%pars(ind_s_alb_l_green,is)
+                            surf_usm_h(l)%aldif(m,ind_pav_green) =                         &
+                                     building_surface_pars_f%pars(ind_s_alb_l_green,is)
+                            surf_usm_h(l)%albedo_type(m,ind_pav_green) = 0
+                         ENDIF
+
+                         IF ( building_surface_pars_f%pars(ind_s_alb_s_green,is) /=     &
+                              building_surface_pars_f%fill )  THEN
+                            surf_usm_h(l)%asdir(m,ind_pav_green) =                         &
+                                     building_surface_pars_f%pars(ind_s_alb_s_green,is)
+                            surf_usm_h(l)%asdif(m,ind_pav_green) =                         &
+                                     building_surface_pars_f%pars(ind_s_alb_s_green,is)
+                            surf_usm_h(l)%albedo_type(m,ind_pav_green) = 0
+                         ENDIF
+
+                         EXIT ! surface was found and processed
                       ENDIF
-
-                      IF ( building_surface_pars_f%pars(ind_s_alb_l_wall,is) /=      &
-                           building_surface_pars_f%fill )  THEN
-                         surf_usm_h%aldir(m,ind_veg_wall) =                          &
-                                  building_surface_pars_f%pars(ind_s_alb_l_wall,is)
-                         surf_usm_h%aldif(m,ind_veg_wall) =                          &
-                                  building_surface_pars_f%pars(ind_s_alb_l_wall,is)
-                         surf_usm_h%albedo_type(m,ind_veg_wall) = 0
-                      ENDIF
-
-                      IF ( building_surface_pars_f%pars(ind_s_alb_s_wall,is) /=      &
-                           building_surface_pars_f%fill )  THEN
-                         surf_usm_h%asdir(m,ind_veg_wall) =                          &
-                                  building_surface_pars_f%pars(ind_s_alb_s_wall,is)
-                         surf_usm_h%asdif(m,ind_veg_wall) =                          &
-                                  building_surface_pars_f%pars(ind_s_alb_s_wall,is)
-                         surf_usm_h%albedo_type(m,ind_veg_wall) = 0
-                      ENDIF
-
-                      IF ( building_surface_pars_f%pars(ind_s_alb_b_win,is) /=       &
-                           building_surface_pars_f%fill )  THEN
-                         surf_usm_h%albedo(m,ind_wat_win) =                          &
-                                  building_surface_pars_f%pars(ind_s_alb_b_win,is)
-                         surf_usm_h%albedo_type(m,ind_wat_win) = 0
-                      ENDIF
-
-                      IF ( building_surface_pars_f%pars(ind_s_alb_l_win,is) /=       &
-                           building_surface_pars_f%fill )  THEN
-                         surf_usm_h%aldir(m,ind_wat_win) =                           &
-                                  building_surface_pars_f%pars(ind_s_alb_l_win,is)
-                         surf_usm_h%aldif(m,ind_wat_win) =                           &
-                                  building_surface_pars_f%pars(ind_s_alb_l_win,is)
-                         surf_usm_h%albedo_type(m,ind_wat_win) = 0
-                      ENDIF
-
-                      IF ( building_surface_pars_f%pars(ind_s_alb_s_win,is) /=       &
-                           building_surface_pars_f%fill )  THEN
-                         surf_usm_h%asdir(m,ind_wat_win) =                           &
-                                  building_surface_pars_f%pars(ind_s_alb_s_win,is)
-                         surf_usm_h%asdif(m,ind_wat_win) =                           &
-                                  building_surface_pars_f%pars(ind_s_alb_s_win,is)
-                         surf_usm_h%albedo_type(m,ind_wat_win) = 0
-                      ENDIF
-
-                      IF ( building_surface_pars_f%pars(ind_s_alb_b_green,is) /=     &
-                           building_surface_pars_f%fill )  THEN
-                         surf_usm_h%albedo(m,ind_pav_green) =                        &
-                                  building_surface_pars_f%pars(ind_s_alb_b_green,is)
-                         surf_usm_h%albedo_type(m,ind_pav_green) = 0
-                      ENDIF
-
-                      IF ( building_surface_pars_f%pars(ind_s_alb_l_green,is) /=     &
-                           building_surface_pars_f%fill )  THEN
-                         surf_usm_h%aldir(m,ind_pav_green) =                         &
-                                  building_surface_pars_f%pars(ind_s_alb_l_green,is)
-                         surf_usm_h%aldif(m,ind_pav_green) =                         &
-                                  building_surface_pars_f%pars(ind_s_alb_l_green,is)
-                         surf_usm_h%albedo_type(m,ind_pav_green) = 0
-                      ENDIF
-
-                      IF ( building_surface_pars_f%pars(ind_s_alb_s_green,is) /=     &
-                           building_surface_pars_f%fill )  THEN
-                         surf_usm_h%asdir(m,ind_pav_green) =                         &
-                                  building_surface_pars_f%pars(ind_s_alb_s_green,is)
-                         surf_usm_h%asdif(m,ind_pav_green) =                         &
-                                  building_surface_pars_f%pars(ind_s_alb_s_green,is)
-                         surf_usm_h%albedo_type(m,ind_pav_green) = 0
-                      ENDIF
-
-                      EXIT ! surface was found and processed
-                   ENDIF
+                   ENDDO
                 ENDDO
              ENDDO
-
              DO  l = 0, 3
                 DO  m = 1, surf_usm_v(l)%ns
@@ -2729,6 +2755,8 @@
 !
 !--          Horizontally aligned natural and urban surfaces
-             CALL calc_albedo( surf_lsm_h )
-             CALL calc_albedo( surf_usm_h )
+             DO l = 0, 1
+                CALL calc_albedo( surf_lsm_h(l) )
+                CALL calc_albedo( surf_usm_h(l) )
+             ENDDO
 !
 !--          Vertically aligned natural and urban surfaces
@@ -2742,16 +2770,18 @@
 !--          Initialize sun-inclination independent spectral albedos
 !--          Horizontal surfaces
-             IF ( surf_lsm_h%ns > 0 )  THEN
-                surf_lsm_h%rrtm_aldir = surf_lsm_h%aldir
-                surf_lsm_h%rrtm_asdir = surf_lsm_h%asdir
-                surf_lsm_h%rrtm_aldif = surf_lsm_h%aldif
-                surf_lsm_h%rrtm_asdif = surf_lsm_h%asdif
-             ENDIF
-             IF ( surf_usm_h%ns > 0 )  THEN
-                surf_usm_h%rrtm_aldir = surf_usm_h%aldir
-                surf_usm_h%rrtm_asdir = surf_usm_h%asdir
-                surf_usm_h%rrtm_aldif = surf_usm_h%aldif
-                surf_usm_h%rrtm_asdif = surf_usm_h%asdif
-             ENDIF
+             DO  l = 0, 1
+                IF ( surf_lsm_h(l)%ns > 0 )  THEN
+                   surf_lsm_h(l)%rrtm_aldir = surf_lsm_h(l)%aldir
+                   surf_lsm_h(l)%rrtm_asdir = surf_lsm_h(l)%asdir
+                   surf_lsm_h(l)%rrtm_aldif = surf_lsm_h(l)%aldif
+                   surf_lsm_h(l)%rrtm_asdif = surf_lsm_h(l)%asdif
+                ENDIF
+                IF ( surf_usm_h(l)%ns > 0 )  THEN
+                   surf_usm_h(l)%rrtm_aldir = surf_usm_h(l)%aldir
+                   surf_usm_h(l)%rrtm_asdir = surf_usm_h(l)%asdir
+                   surf_usm_h(l)%rrtm_aldif = surf_usm_h(l)%aldif
+                   surf_usm_h(l)%rrtm_asdif = surf_usm_h(l)%asdif
+                ENDIF
+             ENDDO
 !
 !--          Vertical surfaces
@@ -3287,8 +3317,10 @@
 !--    First, horizontal surfaces
        horizontal = .TRUE.
-       surf => surf_lsm_h
-       CALL radiation_external_surf
-       surf => surf_usm_h
-       CALL radiation_external_surf
+       DO  l = 0, 1
+          surf => surf_lsm_h(l)
+          CALL radiation_external_surf
+          surf => surf_usm_h(l)
+          CALL radiation_external_surf
+       ENDDO
        horizontal = .FALSE.
 !
@@ -3567,8 +3599,10 @@
 !--    First, horizontal surfaces
        horizontal = .TRUE.
-       surf => surf_lsm_h
-       CALL radiation_clearsky_surf
-       surf => surf_usm_h
-       CALL radiation_clearsky_surf
+       DO  l = 0, 1
+          surf => surf_lsm_h(l)
+          CALL radiation_clearsky_surf
+          surf => surf_usm_h(l)
+          CALL radiation_clearsky_surf
+       ENDDO
        horizontal = .FALSE.
 !
@@ -3752,8 +3786,10 @@
 !--    First, horizontal surfaces
        horizontal = .TRUE.
-       surf => surf_lsm_h
-       CALL radiation_constant_surf
-       surf => surf_usm_h
-       CALL radiation_constant_surf
+       DO  l = 0, 1
+          surf => surf_lsm_h(l)
+          CALL radiation_constant_surf
+          surf => surf_usm_h(l)
+          CALL radiation_constant_surf
+       ENDDO
        horizontal = .FALSE.
 !
@@ -4125,6 +4161,8 @@
 !
 !--       Horizontally aligned default, natural and urban surfaces
-          CALL calc_albedo( surf_lsm_h    )
-          CALL calc_albedo( surf_usm_h    )
+          DO  l = 0, 1
+             CALL calc_albedo( surf_lsm_h(l) )
+             CALL calc_albedo( surf_usm_h(l) )
+          ENDDO
 !
 !--       Vertically aligned default, natural and urban surfaces
@@ -4472,9 +4510,9 @@
 !
 !--             Prepare profiles of temperature and H2O volume mixing ratio
-                DO  m = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
-                   rrtm_tlev(0,nzb+1) = surf_lsm_h%pt_surface(m) * exner(nzb)
+                DO  m = surf_lsm_h(0)%start_index(j,i), surf_lsm_h(0)%end_index(j,i)
+                   rrtm_tlev(0,nzb+1) = surf_lsm_h(0)%pt_surface(m) * exner(nzb)
                 ENDDO
-                DO  m = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
-                   rrtm_tlev(0,nzb+1) = surf_usm_h%pt_surface(m) * exner(nzb)
+                DO  m = surf_usm_h(0)%start_index(j,i), surf_usm_h(0)%end_index(j,i)
+                   rrtm_tlev(0,nzb+1) = surf_usm_h(0)%pt_surface(m) * exner(nzb)
                 ENDDO
 
